#include "crc.h"

bitwiseCRC::bitwiseCRC(unsigned long Poly/*=0xEDB88320*/)
begin
  if (CRC_table=(unsigned long*)malloc(sizeof(unsigned long)*256))==NIL then throw StdMemErr();
  Init(Poly);
end;

bitwiseCRC::~bitwiseCRC()
begin
  free(CRC_table);
end;

bitwiseCRC& bitwiseCRC::Init(unsigned long Poly/*=0*/)
begin
  if Poly!=0 then   //compute a new look-up table for fast ProcessByte()
  begin
    CRCPoly=Poly;

    unsigned W=0;
    repeat
      CRC=0;
      byte B=W;

      for (int count=8; --count>=0;) //do
      begin
        ProcessBit(B bAND 1);
        B=B shr 1;
      end;
      CRC_table[W]=CRC;

      W++;
    until (W==256);
  end;

  CRC=(unsigned long)-1;  //start value -1 to match algorithm used for .PNGs
  return *this;
end;

bitwiseCRC& bitwiseCRC::ProcessBit(unsigned Bit)
begin
  Bit=(Bit bXOR CRC) bAND 1;
  CRC=CRC shr 1;
  if Bit==1 then CRC=CRC bXOR CRCPoly;
  return *this;
end;

bitwiseCRC& bitwiseCRC::ProcessByte(unsigned Byte)
begin
  Byte=(Byte bXOR CRC) bAND 255;
  CRC=(CRC shr 8) bXOR CRC_table[Byte];
  return *this;
end;

